#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Foo to Foobar
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>CorG Tool>Foo to Foobar
#		 Note:	
#			
#    Date:	Apr 2017
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_CorG_tools.add_item("Foo to Foobar") { SDM::Foo_to_Foobar.main }
	tb = UI::Toolbar.new("Toolbar Name")
	cmd = UI::Command.new("Foo to Foobar") { SDM::Foo_to_Foobar.main }
	cmd.tooltip = "Foo to Foobar"
	# cmd.status_bar_text = "Foo to Foobar"
	# cmd.large_icon = File.join(File.dirname(__FILE__), "/Large Icon.png")
	# cmd.small_icon = File.join(File.dirname(__FILE__), "/Small Icon.png")
	tb.add_item(cmd); tb.show unless tb.get_last_state == 0
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Foo_to_Foobar

		def self.main
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			mod.start_operation "Foo to Foobar"
			#
			ents = sel.empty? ? ent.to_a : sel.to_a
			tran = IDENTITY; @rmv = []
			@fbd = mod.definitions.add('foobar')
			@fbe = @fbd.entities
			self.find_foos(ents,tran)
			tran = Geom::Transformation.new(@fbd.bounds.min)
			ent.add_instance(@fbd,tran); 
			@rmv.reverse.each{|e|e.erase!}
			#
			mod.commit_operation
		end
		
		def self.find_foos(ee,tr)
			ee.each{|e|
				next if !e.is_a?(Sketchup::ComponentInstance)
				if e.definition.name=='foo'
					fb = @fbe.add_instance(e.definition,tr*e.transformation)
					fb.definition.name='_foo_' if Sketchup.version.to_i>=14
					fb.definition.name='foo'
					@rmv << e
				else
					t = tr * e.transformation
					self.find_foos(e.definition.entities,t)
				end
			}
		end
		
	end
end


